// DialogCPCL.cpp : ʵļ
//

#include "stdafx.h"
#include "TestPOS.h"
#include "DialogCPCL.h"

//CPCL
#define CPCL_SUCCESS					0L
#define CPCL_IDERROR					-1L
#define CPCL_WRITEFAIL                  -2L //дʧ
#define CPCL_READFAIL                   -3L //ʧ
#define CPCL_PARAM_INVALID              -4L //Ч
#define CPCL_OVERTIME                  -5L //ʱ/дʱ/ʱ/ӡδ
#define CPCL_OTHERERRORS               -100L //ԭµĴ

//Dimensional barcode type
#define CPCL_BT_PDF417		4100L
#define CPCL_BT_DATAMATRIX	4101L
#define CPCL_BT_QRCODE		4102L


//ҳҳ
typedef LONG (WINAPI *CallPageSetupCPCL)(LONG iPrinterID,INT offset,INT height,INT qty, INT width);

//
typedef LONG (WINAPI *CallDrawLineCPCL)(LONG iPrinterID,INT x0,INT y0,INT x1,INT y1,INT width);

//ʾ
typedef LONG (WINAPI *CallSetInverseTextCPCL)(LONG iPrinterID,INT value);

//뷽ʽ
typedef LONG (WINAPI *CallSetAlignCPCL)(LONG iPrinterID,INT value);

//Ӵ
typedef LONG (WINAPI *CallSetBoldCPCL)(LONG iPrinterID,INT value);

//»
typedef LONG (WINAPI *CallSetUnderLineTextCPCL)(LONG iPrinterID,INT value);

//ַ
typedef LONG (WINAPI *CallSetSpacingCPCL)(LONG iPrinterID,INT value);

//
typedef LONG (WINAPI *CallDrawBoxCPCL)(LONG iPrinterID,INT x0,INT y0,INT x1,INT y1,INT width);

//
typedef LONG (WINAPI *CallDrawTextCPCL)(LONG iPrinterID,INT value,INT font,INT vsize,INT hsize,INT x,INT y,LPCSTR data);

//һά
typedef LONG (WINAPI *CallDrawBarCodeCPCL)(LONG iPrinterID,INT value,LPCSTR type,INT width,INT ratio,INT height,INT x, INT y, LPCSTR data);

//ջ
//typedef LONG (WINAPI *CallClearBuffCPCL)(LONG iPrinterID);

//QRά
typedef LONG (WINAPI *CallDraw2BarCodeQRCPCL)(LONG iPrinterID,INT x, INT y, INT Mn, INT Un, CHAR Sn, LPCSTR data);

//PDF417ά
typedef LONG (WINAPI *CallDraw2BarCodePDF417CPCL)(LONG iPrinterID,INT x, INT y, INT XDn, INT YDn, INT Cn, INT Sn, LPCSTR content);

//ӡͼƬ
typedef LONG (WINAPI *CallPrintBMPCPCL)(LONG iPrinterID,INT type,INT x,INT y,LPCSTR lpFilePath);

//(Իߵķʽȡ)
typedef LONG (WINAPI *CallInverseLineCPCL)(LONG iPrinterID,INT x0,INT y0,INT x1,INT y1,INT width);

//HRIַһάԶӡ
typedef LONG (WINAPI *CallSetHRICPCL)(LONG iPrinterID,LPCSTR offset);

//ҳ˳ʱת90
typedef LONG (WINAPI *CallSetPageRotateCPCL)(LONG iPrinterID,INT value);

//ӡ
typedef LONG (WINAPI *CallPrintCPCL)(LONG iPrinterID);

//ҷ϶
typedef LONG (WINAPI *CallFormCPCL)(LONG iPrinterID);


extern CallPageSetupCPCL						CPCL_PageSetup;
extern CallDrawLineCPCL							CPCL_DrawLine;
extern CallPrintCPCL						    CPCL_Print;
extern CallDrawBoxCPCL						    CPCL_DrawBox;
extern CallDrawTextCPCL							CPCL_DrawText;
extern CallDrawBarCodeCPCL						CPCL_DrawBarCode;
extern CallSetInverseTextCPCL				    CPCL_SetInverseText;
extern CallSetAlignCPCL							CPCL_SetAlign;
extern CallSetBoldCPCL							CPCL_SetBold;
extern CallSetUnderLineTextCPCL					CPCL_SetUnderLineText;
extern CallSetSpacingCPCL					    CPCL_SetSpace;
//extern CallClearBuffCPCL						ClearBuffCPCL;
extern CallDraw2BarCodeQRCPCL					CPCL_Draw2Barcode_QR;
extern CallDraw2BarCodePDF417CPCL				CPCL_Draw2Barcode_PDF417;
extern CallPrintBMPCPCL							CPCL_PrintBMP;
extern CallFormCPCL					            CPCL_Form;
extern CallInverseLineCPCL						CPCL_InverseLine;
extern CallSetHRICPCL							CPCL_SetHRI;
extern CallSetPageRotateCPCL					CPCL_SetPageRotate;
extern LONG m_hPrinter;

// CDialogCPCL Ի

IMPLEMENT_DYNAMIC(CDialogCPCL, CDialog)

CDialogCPCL::CDialogCPCL(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogCPCL::IDD, pParent)
{

}

CDialogCPCL::~CDialogCPCL()
{
}

void CDialogCPCL::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_BARCODETYPE, m_BarcodeType);
	DDX_Control(pDX, IDC_STATIC_BITMAP, m_strBitmapStatic);
	DDX_Control(pDX, IDC_STATIC41, m_MnStatic);
	DDX_Control(pDX, IDC_STATIC43, m_UnStatic);
	DDX_Control(pDX, IDC_STATIC44, m_CnStatic);
	DDX_Control(pDX, IDC_STATIC45, m_XDnStatic);
	DDX_Control(pDX, IDC_STATIC47, m_YDnStatic);
	//DDX_Control(pDX, IDC_EDIT_TWOCOD_WIDTH, m_twocodwidth);
	//DDX_Control(pDX, IDC_COMBO_TWOCODE_CELL_WIDTH, m_twocodecellwidth);
	//DDX_Control(pDX, IDC_EDIT_TWOCOD_HEIGHT, m_twocodeheight);
	//DDX_Control(pDX, IDC_COMBO_TWOCODE_LEVEL, m_twocodelevel);

	DDX_Control(pDX, IDC_EDIT_OFFSET, m_offset);
	DDX_Control(pDX, IDC_EDIT_QTY, m_qty);
}


BEGIN_MESSAGE_MAP(CDialogCPCL, CDialog)
	ON_BN_CLICKED(IDC_BUTTON3, &CDialogCPCL::OnBnClickedButton3)
	ON_BN_CLICKED(IDC_BUTTON_PRINTLINE, &CDialogCPCL::OnBnClickedButtonPrintline)
	ON_BN_CLICKED(IDC_BUTTON_PRINTRECT, &CDialogCPCL::OnBnClickedButtonPrintrect)
	//ON_BN_CLICKED(IDC_BUTTON_PRINTRECT2, &CDialogCPCL::OnBnClickedButtonPrintrect2)
	ON_BN_CLICKED(IDC_BUTTON_PRINTBARCODE, &CDialogCPCL::OnBnClickedButtonPrintbarcode)
	//ON_BN_CLICKED(IDC_BUTTON_PRINTBARCODE2, &CDialogCPCL::OnBnClickedButtonPrintbarcode2)
	ON_BN_CLICKED(IDC_BUTTON_PRINTBARCODE3, &CDialogCPCL::OnBnClickedButtonPrintbarcode3)
	ON_CBN_SELCHANGE(IDC_COMBO_TWOCODE_TYPE, &CDialogCPCL::OnCbnSelchangeComboTwocodeType)
	ON_BN_CLICKED(IDC_BUTTON_PRINTTEXT, &CDialogCPCL::OnBnClickedButtonPrinttext)
	ON_BN_CLICKED(IDC_BUTTON_PRINT_BITMAP, &CDialogCPCL::OnBnClickedButtonPrintBitmap)
	ON_BN_CLICKED(IDC_CHECK_INVERSE_LINE, &CDialogCPCL::OnBnClickedCheckInverseLine)
END_MESSAGE_MAP()


// CDialogCPCL Ϣ

void CDialogCPCL::ButtonInit()
{
	CString prompt;
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->SetWindowText("385");
	GetDlgItem(IDC_EDIT_OFFSET)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_QTY)->SetWindowText("1");

	//ֱ
	GetDlgItem(IDC_EDIT_LINEXSTARTPOS)->SetWindowText("10");
	GetDlgItem(IDC_EDIT_LINEYSTARTPOS)->SetWindowText("10");
	GetDlgItem(IDC_EDIT_LINEXENDPOS)->SetWindowText("100");
	GetDlgItem(IDC_EDIT_LINEYENDPOS)->SetWindowText("100");
	GetDlgItem(IDC_EDIT_LINEWIDTH)->SetWindowText("1");

	// 5,20,20,200,200
	GetDlgItem(IDC_EDIT_RECTLINEWIDTH)->SetWindowText("5");
	GetDlgItem(IDC_EDIT_TOPLEFTXPOS)->SetWindowText("20");
	GetDlgItem(IDC_EDIT_TOPLEFTYOS)->SetWindowText("20");
	GetDlgItem(IDC_EDIT_RIGHTBOTTOMXPOS)->SetWindowText("200");
	GetDlgItem(IDC_EDIT_RIGHTBOTTOMYPOS)->SetWindowText("200");

	// 0,0,TRUE,1,1,0,"DrawTextCPCL"
	GetDlgItem(IDC_EDIT_TEXTXPOS)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_TEXTYPOS)->SetWindowText("0");
	((CComboBox*)GetDlgItem(IDC_COMBO_FONT))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_COMBO_VSIZE))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_COMBO_HSIZE))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_COMBO_TEXTROTATE))->SetCurSel(0);
	GetDlgItem(IDC_EDIT_TEXTSPCAE)->SetWindowText("0");
	((CComboBox*)GetDlgItem(IDC_COMBO_Align))->SetCurSel(0);
	((CComboBox*)GetDlgItem(IDC_COMBO10))->SetCurSel(0);
	prompt.LoadString(IDS_TSPL_Text);
	GetDlgItem(IDC_EDIT_TEXTCONTENT)->SetWindowText(prompt);
	

	// UPCAUPCEEAN13EAN839CODABAR93128
	m_BarcodeType.ResetContent();
	m_BarcodeType.AddString("UPCA");
	m_BarcodeType.AddString("UPCE");
	m_BarcodeType.AddString("EAN13");
	m_BarcodeType.AddString("EAN8");
	m_BarcodeType.AddString("39");
	m_BarcodeType.AddString("CODABAR");
	m_BarcodeType.AddString("93");
	m_BarcodeType.AddString("128");
	
	// 10,10,"128",30,TRUE,0,2,4,"123456"
	GetDlgItem(IDC_EDIT_BARCODEXPOS)->SetWindowText("10");
	GetDlgItem(IDC_EDIT_BARCODEYPOS)->SetWindowText("10");
	m_BarcodeType.SetCurSel(7);
	GetDlgItem(IDC_EDIT_BARCODEHEIGHT)->SetWindowText("30");
	((CComboBox*)GetDlgItem(IDC_COMBO_BARCODE_DIRECTION))->SetCurSel(0);
	GetDlgItem(IDC_EDIT_BARCODENARROW_WIDTH)->SetWindowText("2");
	GetDlgItem(IDC_EDIT_BARCODE_RATIO)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_BARCODECONTENT)->SetWindowText("NO.123456");
	
	//ͼƬ
	GetDlgItem(IDC_EDIT_PICXPOS)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_PICYPOS)->SetWindowText("0");
	((CComboBox *)GetDlgItem(IDC_COMBO_BITMAP_SEL))->SetCurSel(0);
	((CComboBox *)GetDlgItem(IDC_COMBO_PAGE_ROTATE))->SetCurSel(0);

	//ά
	m_CnStatic.ShowWindow(SW_HIDE);
	m_XDnStatic.ShowWindow(SW_HIDE);
	m_YDnStatic.ShowWindow(SW_HIDE);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_Cn))->ShowWindow(SW_HIDE);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_XDn))->ShowWindow(SW_HIDE);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_YDn))->ShowWindow(SW_HIDE);
	GetDlgItem(IDC_EDIT_TWOCODE_XPOS)->SetWindowText("0");
	GetDlgItem(IDC_EDIT_TWOCODE_YPOS)->SetWindowText("0");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->AddString("CPCL_BT_QRCODE");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->AddString("CPCL_BT_PDF417");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->SetCurSel(0);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Mn))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Mn))->AddString("1");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Mn))->AddString("2");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Mn))->SetCurSel(1);
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->AddString("1");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->AddString("2");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->AddString("3");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->AddString("4");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->AddString("5");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->AddString("6");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->SetCurSel(5);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("L");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("M");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("Q");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("H");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->SetCurSel(0);
	
	GetDlgItem(IDC_EDIT_TWOCODE_CONTENT)->SetWindowText("www.test.com");
}


BOOL CDialogCPCL::OnInitDialog()
{
	CDialog::OnInitDialog();

	ButtonInit();

	return TRUE;
}


void CDialogCPCL::OnBnClickedButton3()
{
	m_strTmp.LoadString(IDS_Bitmap_File_Filter);
	//unsigned long size = GetCurrentDirectory(0, NULL);
	/*TCHAR* path = new TCHAR[size];
	if(GetCurrentDirectory(size, path) == 0 ){
		MessageBox("GetCurrentDirectory Error");
		delete[] path;
		return;
	}*/

	CFileDialog dlg(TRUE,_T("bmp"),_T(".bmp"), OFN_NOCHANGEDIR|OFN_EXPLORER, m_strTmp, NULL, 0, TRUE);
	if(dlg.DoModal() == IDOK)
	{
		m_strImagePath = dlg.GetPathName();
		((CEdit *)GetDlgItem(IDC_EDIT_PICTUREPATH))->SetWindowText(m_strImagePath);
		ShowImage(m_strImagePath);
	}
	/*SetCurrentDirectory(path);
	delete[] path;*/
}

void CDialogCPCL::ShowImage(CString path)
{
	CRect lRect;
	m_strBitmapStatic.GetClientRect(&lRect);

	CImage image;
	image.Load(path);
	int width = image.GetWidth();
	int height = image.GetHeight();

	int realWidth, realHeight;

	if(width > height)
	{
		realWidth = lRect.Width();
		realHeight = realWidth * height / width;
	}
	else
	{
		realHeight = lRect.Height();
		realWidth = realHeight * width / height;
	}

	//һNULL ʾʹڲԴļⲿͼƬ
	m_hCurrentSelBitmap = (HBITMAP)::LoadImage (NULL,path,IMAGE_BITMAP,realWidth,realHeight,LR_LOADFROMFILE|LR_CREATEDIBSECTION);
	// ʾͼƬ
	m_strBitmapStatic.SetBitmap(m_hCurrentSelBitmap);

	Invalidate(TRUE);
}


void CDialogCPCL::OnBnClickedButtonPrintline()
{
	CString prompt;
	//ӡֱ
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	GetDlgItem(IDC_EDIT_OFFSET)->GetWindowText(m_strOffset);
	GetDlgItem(IDC_EDIT_QTY)->GetWindowText(m_strQty);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(prompt);
		return;
	}

	CString xStartPos,yStartPos,xEndPos,yEndPos,lineWidth;
	GetDlgItem(IDC_EDIT_LINEXSTARTPOS)->GetWindowText(xStartPos);
	GetDlgItem(IDC_EDIT_LINEYSTARTPOS)->GetWindowText(yStartPos);
	GetDlgItem(IDC_EDIT_LINEWIDTH)->GetWindowText(lineWidth);
	GetDlgItem(IDC_EDIT_LINEXENDPOS)->GetWindowText(xEndPos);
	GetDlgItem(IDC_EDIT_LINEYENDPOS)->GetWindowText(yEndPos);

	if (xStartPos == "" || yStartPos == "" || lineWidth == "" || xEndPos == "" || yEndPos == ""){
		prompt.LoadString(IDS_TSPL_Line_Start);
		AfxMessageBox(prompt);
		return;
	}

	CString info;
	LONG ret;// = ClearBuffCPCL(m_hPrinter);
	//if(ret < 0)	
	//{
	//	info.Format("ClearBuffCPCLm_hPrinter:%d",ret);
	//	MessageBox(info);
	//	return;
	//}

	ret = CPCL_PageSetup(m_hPrinter,atoi(m_strOffset),atoi(m_strPageHeight),atoi(m_strQty),atoi(m_strPageWidth));
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt,"PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	}

	//
	ret = CPCL_DrawLine(m_hPrinter,atoi(xStartPos),atoi(yStartPos),atoi(xEndPos),atoi(yEndPos),atoi(lineWidth));
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt,"DrawLine",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt,"DrawLine",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "DrawLine",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "DrawLine",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "DrawLine",ret);
		MessageBox(info);
		return;
	}
	CPCL_Form(m_hPrinter);
	CPCL_Print(m_hPrinter);
}

void CDialogCPCL::OnBnClickedButtonPrintrect()
{
	CString prompt;
	//ӡ
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	GetDlgItem(IDC_EDIT_OFFSET)->GetWindowText(m_strOffset);
	GetDlgItem(IDC_EDIT_QTY)->GetWindowText(m_strQty);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(prompt);
		return;
	}

	CString strLeft,strTop,strRight,strBottom,strLineWidth;
	GetDlgItem(IDC_EDIT_TOPLEFTXPOS)->GetWindowText(strLeft);
	GetDlgItem(IDC_EDIT_TOPLEFTYOS)->GetWindowText(strTop);
	GetDlgItem(IDC_EDIT_RIGHTBOTTOMXPOS)->GetWindowText(strRight);
	GetDlgItem(IDC_EDIT_RIGHTBOTTOMYPOS)->GetWindowText(strBottom);
	GetDlgItem(IDC_EDIT_RECTLINEWIDTH)->GetWindowText(strLineWidth);

	if (strLeft == "" || strTop == "" || strRight == "" || strBottom == "" || strLineWidth == "" ){
		prompt.LoadString(IDS_TSPL_Line_Start);
		AfxMessageBox(prompt);
		return;
	}

	CString info;
	LONG ret;// = ClearBuffCPCL(m_hPrinter);
	//if(ret < 0)	
	//{
	//	info.Format("ClearBuffCPCLm_hPrinter:%d",ret);
	//	MessageBox(info);
	//	return;
	//}

	ret = CPCL_PageSetup(m_hPrinter,atoi(m_strOffset),atoi(m_strPageHeight),atoi(m_strQty),atoi(m_strPageWidth));
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	}

	//
	ret = CPCL_DrawBox(m_hPrinter,atoi(strLeft),atoi(strTop),atoi(strRight),atoi(strBottom),atoi(strLineWidth));
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "DrawBox",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "DrawBox",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "DrawBox",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "DrawBox",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "DrawBox",ret);
		MessageBox(info);
		return;
	}
    CPCL_Form(m_hPrinter);
	CPCL_Print(m_hPrinter);

}


void CDialogCPCL::OnBnClickedButtonPrintbarcode()
{
	CString prompt;
	//ӡ
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	GetDlgItem(IDC_EDIT_OFFSET)->GetWindowText(m_strOffset);
	GetDlgItem(IDC_EDIT_QTY)->GetWindowText(m_strQty);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(prompt);
	    return;
	}

	CString xPos,yPos,strContent,strNarrowWidth,strRatio,strCodeHeight;
	GetDlgItem(IDC_EDIT_BARCODEXPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_BARCODEYPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_BARCODENARROW_WIDTH)->GetWindowText(strNarrowWidth);
	GetDlgItem(IDC_EDIT_BARCODE_RATIO)->GetWindowText(strRatio);
	GetDlgItem(IDC_EDIT_BARCODEHEIGHT)->GetWindowText(strCodeHeight);
	GetDlgItem(IDC_EDIT_BARCODECONTENT)->GetWindowText(strContent);
	if (xPos == "" || yPos == "" || strContent == "" ||
		strNarrowWidth == "" || strRatio == "" || strCodeHeight == "" ){
		prompt.LoadString(IDS_TSPL_OneBar_Parameter);
		AfxMessageBox(prompt);
		return;
	}

	CString info;
	LONG ret;// = ClearBuffCPCL(m_hPrinter);
	//if(ret < 0)	
	//{
	//	info.Format("ClearBuffCPCLm_hPrinter:%d",ret);
	//	MessageBox(info);
	//	return;
	//}
	
	ret = CPCL_PageSetup(m_hPrinter,atoi(m_strOffset),atoi(m_strPageHeight),atoi(m_strQty),atoi(m_strPageWidth));
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	}
	CString offset;
	((CEdit*)GetDlgItem(IDC_EDIT_BARCODEOFFSET))->GetWindowText(offset);
	if (offset != "")
	{
	    CPCL_SetHRI(m_hPrinter,offset);
	}

	//һά
	CString strCodeType;
	((CComboBox*)GetDlgItem(IDC_COMBO_BARCODETYPE))->GetWindowText(strCodeType);	

	ret = CPCL_DrawBarCode(m_hPrinter,((CComboBox*)GetDlgItem(IDC_COMBO_BARCODE_DIRECTION))->GetCurSel(),strCodeType,atoi(strNarrowWidth),atoi(strRatio),atoi(strCodeHeight),
									atoi(xPos),atoi(yPos),strContent);
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "DrawBarCode",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "DrawBarCode",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "DrawBarCode",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "DrawBarCode",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "DrawBarCode",ret);
		MessageBox(info);
		return;
	
	}
	if (offset != "")
	    CPCL_SetHRI(m_hPrinter,"OFF");
    CPCL_Form(m_hPrinter);
	CPCL_Print(m_hPrinter);

}

void CDialogCPCL::OnBnClickedButtonPrintbarcode3()
{
	INT nType = 0;
	INT para1, para2,para3,para4;
    CString strPara1,strPara2,strPara3,strPara4;
	CString prompt;
	//ӡά
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	GetDlgItem(IDC_EDIT_OFFSET)->GetWindowText(m_strOffset);
	GetDlgItem(IDC_EDIT_QTY)->GetWindowText(m_strQty);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(prompt);
		return;
	}

	CString xPos,yPos,strContent;
	GetDlgItem(IDC_EDIT_TWOCODE_XPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_TWOCODE_YPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_TWOCODE_CONTENT)->GetWindowText(strContent);
	if (xPos == "" || yPos == "" || strContent == ""){
		prompt.LoadString(IDS_TSPL_BarTwo_Content);
		AfxMessageBox(prompt);
		return;
	}


	CString info;
	LONG ret;// = ClearBuffCPCL(m_hPrinter);
	//if(ret < 0)	
	//{
	//	info.Format("ClearBuffCPCLm_hPrinter:%d",ret);
	//	MessageBox(info);
	//	return;
	//}

	ret = CPCL_PageSetup(m_hPrinter,atoi(m_strOffset),atoi(m_strPageHeight),atoi(m_strQty),atoi(m_strPageWidth));
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	}

	switch (((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->GetCurSel())
	{
	case 0:
		nType = CPCL_BT_QRCODE;
		((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Mn))->GetWindowText(strPara1);
		para1 = atoi(strPara1);
		((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->GetWindowText(strPara2);
		para2 = atoi(strPara2);
		((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->GetWindowText(strPara3);
		ret = CPCL_Draw2Barcode_QR(m_hPrinter,atoi(xPos),atoi(yPos),para1,para2, *(strPara3.GetBuffer(0)) ,strContent);
		break;
	case 1:
		nType = CPCL_BT_PDF417;
		GetDlgItem(IDC_EDIT_TWOCODE_Cn)->GetWindowText(strPara1);
		GetDlgItem(IDC_EDIT_TWOCODE_XDn)->GetWindowText(strPara2);
		para2 = atoi(strPara2);
		para1 = atoi(strPara1);
		((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->GetWindowText(strPara3);
		para3 = atoi(strPara3);
		GetDlgItem(IDC_EDIT_TWOCODE_YDn)->GetWindowText(strPara4);
		para4 = atoi(strPara4);
		ret = CPCL_Draw2Barcode_PDF417(m_hPrinter,atoi(xPos),atoi(yPos),para2,para4,para1,para3,strContent);
		break;
	default:
		return;
	}

	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "Draw2Barcode",ret);
		MessageBox(info);
		return;
	
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "Draw2Barcode",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "Draw2Barcode",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "Draw2Barcode",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "Draw2Barcode",ret);
		MessageBox(info);
		return;
	}
    CPCL_Form(m_hPrinter);
	CPCL_Print(m_hPrinter);

}

void CDialogCPCL::OnCbnSelchangeComboTwocodeType()
{
	switch (((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_TYPE))->GetCurSel())
	{
	case 1:
		SelchangePDF417();
		break;
	case 0:
		SelchangeQRCODE();
		break;
	}
}
void  CDialogCPCL::SelchangePDF417()
{
	m_CnStatic.ShowWindow(SW_NORMAL);
	m_XDnStatic.ShowWindow(SW_NORMAL);
	m_YDnStatic.ShowWindow(SW_NORMAL);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_Cn))->ShowWindow(SW_NORMAL);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_XDn))->ShowWindow(SW_NORMAL);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_YDn))->ShowWindow(SW_NORMAL);
	m_MnStatic.ShowWindow(SW_HIDE);
	m_UnStatic.ShowWindow(SW_HIDE);
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Mn))->ShowWindow(SW_HIDE);
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->ShowWindow(SW_HIDE);

	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_Cn))->SetWindowText("3");
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_XDn))->SetWindowText("2");
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_YDn))->SetWindowText("6");

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("1");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("2");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("3");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("4");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("5");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("6");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("7");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("8");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->SetCurSel(0);
   
}


void  CDialogCPCL::SelchangeQRCODE()
{
	m_CnStatic.ShowWindow(SW_HIDE);
	m_XDnStatic.ShowWindow(SW_HIDE);
	m_YDnStatic.ShowWindow(SW_HIDE);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_Cn))->ShowWindow(SW_HIDE);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_XDn))->ShowWindow(SW_HIDE);
	((CEdit*)GetDlgItem(IDC_EDIT_TWOCODE_YDn))->ShowWindow(SW_HIDE);
	m_MnStatic.ShowWindow(SW_NORMAL);
	m_UnStatic.ShowWindow(SW_NORMAL);
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Un))->ShowWindow(SW_NORMAL);
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_Mn))->ShowWindow(SW_NORMAL);

	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->ResetContent();
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("L");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("M");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("Q");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->AddString("H");
	((CComboBox*)GetDlgItem(IDC_COMBO_TWOCODE_LEVEL))->SetCurSel(0);
}

void CDialogCPCL::OnBnClickedButtonPrinttext()
{
	CString prompt;
	//ӡ
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	GetDlgItem(IDC_EDIT_OFFSET)->GetWindowText(m_strOffset);
	GetDlgItem(IDC_EDIT_QTY)->GetWindowText(m_strQty);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(prompt);
		return;
	}

	CString xPos,yPos,strContent;
	GetDlgItem(IDC_EDIT_TEXTXPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_TEXTYPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_TEXTCONTENT)->GetWindowText(strContent);


	if (xPos == "" || yPos == "" || strContent == "" ){
		prompt.LoadString(IDS_TSPL_Content_Point);
		AfxMessageBox(prompt);
		return;
	}



	CString info;
	LONG ret;// = ClearBuffCPCL(m_hPrinter);
	//if(ret < 0)	
	//{
	//		info.Format("ClearBuffCPCLm_hPrinter:%d",ret);
	//		MessageBox(info);
	//		return;
	//	}

	ret = CPCL_PageSetup(m_hPrinter,atoi(m_strOffset),atoi(m_strPageHeight),atoi(m_strQty),atoi(m_strPageWidth));
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	}
	if(BST_CHECKED==((CButton*)GetDlgItem(IDC_CHECK2))->GetCheck()) //״ӡ
	{
		CPCL_SetInverseText(m_hPrinter,1);
	}
	else
	{
		CPCL_SetInverseText(m_hPrinter,0);
	}

	CPCL_SetAlign(m_hPrinter,((CComboBox*)GetDlgItem(IDC_COMBO_Align))->GetCurSel()); //뷽ʽ

	CPCL_SetUnderLineText(m_hPrinter,((CComboBox*)GetDlgItem(IDC_COMBO10))->GetCurSel()); //»

	if (BST_CHECKED==((CButton*)GetDlgItem(IDC_CHECK6))->GetCheck()) //Ӵ
	{
		CPCL_SetBold(m_hPrinter,1);
	}
	else
	{
		CPCL_SetBold(m_hPrinter,0);
	}

	CString space;
	GetDlgItem(IDC_EDIT_TEXTSPCAE)->GetWindowText(space);
	CPCL_SetSpace(m_hPrinter,atoi(space)); //ַ

	INT v_size = ((CComboBox*)GetDlgItem(IDC_COMBO_VSIZE))->GetCurSel();
	INT h_size = ((CComboBox*)GetDlgItem(IDC_COMBO_HSIZE))->GetCurSel();
	INT font = ((CComboBox*)GetDlgItem(IDC_COMBO_FONT))->GetCurSel();

	INT iRotate = ((CComboBox*)GetDlgItem(IDC_COMBO_TEXTROTATE))->GetCurSel();
	INT iFont = 24;
	switch(font)
	{
	case 0:
		iFont = 24;
		break;
	case 1:
		iFont = 55;
		break;
	}
	

	//
	ret = CPCL_DrawText(m_hPrinter,iRotate,iFont,v_size,h_size,atoi(xPos),atoi(yPos),strContent);
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "DrawText",ret);
		MessageBox(info);
		break;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "DrawText",ret);
		MessageBox(info);
		break;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "DrawText",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "DrawText",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "DrawText",ret);
		MessageBox(info);
		return;
	}

	if(BST_CHECKED==((CButton*)GetDlgItem(IDC_CHECK_INVERSE_LINE))->GetCheck())
	{
		CString xStartPos,yStartPos,xEndPos,yEndPos,width;
		GetDlgItem(IDC_EDIT_TEXTXSTARTPOS)->GetWindowText(xStartPos);
		GetDlgItem(IDC_EDIT_TEXTYSTARTPOS)->GetWindowText(yStartPos);
		GetDlgItem(IDC_EDIT_TEXTXENDPOS)->GetWindowText(xEndPos);
		GetDlgItem(IDC_EDIT_TEXTYENDPOS)->GetWindowText(yEndPos);
		GetDlgItem(IDC_EDIT_INVERSELINEWIDTH)->GetWindowText(width);


		if (xEndPos == "" || yEndPos == "" || width == "" ){
			prompt.LoadString(IDS_CPCL_InverseLine_End_Width);
			AfxMessageBox(prompt);
			return;
		}
		CPCL_InverseLine(m_hPrinter,atoi(xStartPos),atoi(yStartPos),atoi(xEndPos),atoi(yEndPos),atoi(width));
	}
    CPCL_Form(m_hPrinter);
	CPCL_Print(m_hPrinter);

}


void CDialogCPCL::OnBnClickedButtonPrintBitmap()
{
	CString prompt;
	//ӡͼƬ
	GetDlgItem(IDC_EDIT_PAGEWIDTH)->GetWindowText(m_strPageWidth);
	GetDlgItem(IDC_EDIT_PAGEHEIGHT)->GetWindowText(m_strPageHeight);
	GetDlgItem(IDC_EDIT_OFFSET)->GetWindowText(m_strOffset);
	GetDlgItem(IDC_EDIT_QTY)->GetWindowText(m_strQty);
	if (m_strPageWidth == "" || m_strPageHeight == ""){
		prompt.LoadString(IDS_TSPL_Height_Width);
		AfxMessageBox(prompt);
		return;
	}

	CString xPos,yPos,strPicturePath,strPictureName;
	GetDlgItem(IDC_EDIT_PICXPOS)->GetWindowText(xPos);
	GetDlgItem(IDC_EDIT_PICYPOS)->GetWindowText(yPos);
	GetDlgItem(IDC_EDIT_PICTUREPATH)->GetWindowText(strPicturePath);
	if (xPos == "" || yPos == "" || strPicturePath == ""){
		prompt.LoadString(IDS_TSPL_Bitmap_Path);
		AfxMessageBox(prompt);
		return;
	}


	CString info;
	LONG ret;// = ClearBuffCPCL(m_hPrinter);
	//if(ret < 0)	
	//{
	//	info.Format("ClearBuffCPCLm_hPrinter:%d",ret);
	//	MessageBox(info);
	//	return;
	//}

	ret = CPCL_PageSetup(m_hPrinter,atoi(m_strOffset),atoi(m_strPageHeight),atoi(m_strQty),atoi(m_strPageWidth));
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "PageSetup",ret);
		MessageBox(info);
		return;
	}

	//ӡͼƬ
	INT posA = strPicturePath.ReverseFind('//');
	INT posB = strPicturePath.ReverseFind('.');
	INT len = strPicturePath.GetLength();
	strPictureName = strPicturePath.Mid(posA + 1,posB - posA - 1) + ".BMP";	//ͼƬչǴдBMP garland 2019-03-21
	
	ret = CPCL_PrintBMP(m_hPrinter, ((CComboBox*)GetDlgItem(IDC_COMBO_BITMAP_SEL))->GetCurSel()+1,atoi(xPos),atoi(yPos),strPictureName/*"goodwork.BMP"*/);
	switch(ret)
	{
	case CPCL_IDERROR:
		prompt.LoadString(IDS_CPCL_Fun_Error);
		info.Format(prompt, "PrintBMP",ret);
		MessageBox(info);
		return;
	case CPCL_PARAM_INVALID:
		prompt.LoadString(IDS_CPCL_Parameter_Invalid);
		info.Format(prompt, "PrintBMP",ret);
		MessageBox(info);
		return;
	case CPCL_OVERTIME:
		prompt.LoadString(IDS_CPCL_OverTime);
		info.Format(prompt, "PrintBMP",ret);
		MessageBox(info);
		return;
	case CPCL_OTHERERRORS:
		prompt.LoadString(IDS_CPCL_Other_Errors);
		info.Format(prompt, "PrintBMP",ret);
		MessageBox(info);
		return;
	case CPCL_WRITEFAIL:
		prompt.LoadString(IDS_CPCL_Write_Fail);
		info.Format(prompt, "PrintBMP",ret);
		MessageBox(info);
		return;
	}
	CPCL_SetPageRotate(m_hPrinter,((CComboBox*)GetDlgItem(IDC_COMBO_PAGE_ROTATE))->GetCurSel());

	CPCL_Form(m_hPrinter);
	CPCL_Print(m_hPrinter);
	
}

void CDialogCPCL::OnBnClickedCheckInverseLine()
{
	// TODO: ڴӿؼ֪ͨ
	if(BST_CHECKED==((CButton*)GetDlgItem(IDC_CHECK_INVERSE_LINE))->GetCheck()) //Դӡ
	{
		((CStatic*)GetDlgItem(IDC_STATIC_TEXTX_STARTPOS))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_STATIC_TEXT_STARTY_POS))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_EDIT_TEXTXSTARTPOS))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_EDIT_TEXTYSTARTPOS))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_STATIC_TEXTX_ENDPOS))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_STATIC_TEXT_ENDY_POS))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_EDIT_TEXTXENDPOS))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_EDIT_TEXTYENDPOS))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_STATIC_TEXT_INVERSELINE_WIDTH))->ShowWindow(SW_NORMAL);
		((CStatic*)GetDlgItem(IDC_EDIT_INVERSELINEWIDTH))->ShowWindow(SW_NORMAL);
	}
	else
	{
		((CStatic*)GetDlgItem(IDC_STATIC_TEXTX_ENDPOS))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_STATIC_TEXT_ENDY_POS))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_EDIT_TEXTXENDPOS))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_EDIT_TEXTYENDPOS))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_STATIC_TEXTX_STARTPOS))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_STATIC_TEXT_STARTY_POS))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_EDIT_TEXTXSTARTPOS))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_EDIT_TEXTYSTARTPOS))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_STATIC_TEXT_INVERSELINE_WIDTH))->ShowWindow(SW_HIDE);
		((CStatic*)GetDlgItem(IDC_EDIT_INVERSELINEWIDTH))->ShowWindow(SW_HIDE);
	}
}
